polybori::COrderedIter< NavigatorType, MonomType > Class Template Reference

`#include <BoolePolynomial.h>`

Inheritance diagram for polybori::COrderedIter< NavigatorType, MonomType >:

## Public Types

typedef COrderedIter< NavigatorType, MonomType > | self
typedef CAbstractStackBase< NavigatorType > | stack_base
typedef CTermStackBase< NavigatorType, stack_base > | iterator_core
typedef CTermGenerator< MonomType > | term_generator
| Type for functional, which generates actual term, for current path. More...
typedef iterator_core::const_iterator | const_iterator
typedef iterator_core::const_reverse_iterator | const_reverse_iterator
typedef iterator_core::size_type | size_type
typedef iterator_core::deg_type | deg_type
typedef iterator_core::idx_type | idx_type
typedef NavigatorType | navigator
| Fix type of direct iterator. More...
typedef boost::shared_ptr< iterator_core > | core_pointer
typedef bool | bool_type
| Extract plain Boolean type. More...

## Public Member Functions

| COrderedIter (core_pointer rhs, const term_generator &getTerm)
| ~COrderedIter ()
bool | equal (const self &rhs) const
void | increment ()
| Incrementation. More...
bool_type | isOne () const
| Determine whether term is one (without explicit constructing) More...
bool_type | isZero () const
| Determine whether term is zero (without explicit constructing) More...
bool_type | isEnd () const
| Check, whether end of iteration is reached. More...
MonomType | dereference () const
| Dereferencing operation. More...
const_iterator | begin () const
const_iterator | end () const
const_reverse_iterator | rbegin () const
const_reverse_iterator | rend () const
deg_type | deg () const
idx_type | firstIndex () const
navigator | navigation () const
| Get navigator of term start. More...

## Protected Attributes

term_generator | m_getTerm
| The functional which defines the dereferecing operation. More...
core_pointer | p_iter
| A shared pointer to the stack, which carries the current path. More...

## Member Typedef Documentation

template<class NavigatorType, class MonomType>

typedef bool polybori::COrderedIter< NavigatorType, MonomType >::bool_type

Extract plain Boolean type.

template<class NavigatorType, class MonomType>

typedef iterator_core::const_iterator polybori::COrderedIter< NavigatorType, MonomType >::const_iterator

template<class NavigatorType, class MonomType>

typedef iterator_core::const_reverse_iterator polybori::COrderedIter< NavigatorType, MonomType >::const_reverse_iterator

template<class NavigatorType, class MonomType>

typedef boost::shared_ptr<iterator_core> polybori::COrderedIter< NavigatorType, MonomType >::core_pointer

template<class NavigatorType, class MonomType>

typedef iterator_core::deg_type polybori::COrderedIter< NavigatorType, MonomType >::deg_type

template<class NavigatorType, class MonomType>

typedef iterator_core::idx_type polybori::COrderedIter< NavigatorType, MonomType >::idx_type

template<class NavigatorType, class MonomType>

typedef CTermStackBase<NavigatorType, stack_base> polybori::COrderedIter< NavigatorType, MonomType >::iterator_core

template<class NavigatorType, class MonomType>

typedef NavigatorType polybori::COrderedIter< NavigatorType, MonomType >::navigator

Fix type of direct iterator.

template<class NavigatorType, class MonomType>

typedef COrderedIter<NavigatorType, MonomType> polybori::COrderedIter< NavigatorType, MonomType >::self

template<class NavigatorType, class MonomType>

typedef iterator_core::size_type polybori::COrderedIter< NavigatorType, MonomType >::size_type

template<class NavigatorType, class MonomType>

typedef CAbstractStackBase<NavigatorType> polybori::COrderedIter< NavigatorType, MonomType >::stack_base

template<class NavigatorType, class MonomType>

typedef CTermGenerator<MonomType> polybori::COrderedIter< NavigatorType, MonomType >::term_generator

Type for functional, which generates actual term, for current path.

## Constructor & Destructor Documentation

template<class NavigatorType, class MonomType>

polybori::COrderedIter< NavigatorType, MonomType >::COrderedIter | ( | core_pointer | rhs,
|  | const term_generator & | getTerm
| ) |  |

inline

template<class NavigatorType, class MonomType>

polybori::COrderedIter< NavigatorType, MonomType >::~COrderedIter | ( |  | ) |

inline

## Member Function Documentation

template<class NavigatorType, class MonomType>

const_iterator polybori::COrderedIter< NavigatorType, MonomType >::begin | ( |  | ) | const

inline

Referenced by polybori::groebner::FGLMStrategy::setupMultiplicationTables().

template<class NavigatorType, class MonomType>

deg_type polybori::COrderedIter< NavigatorType, MonomType >::deg | ( |  | ) | const

inline

template<class NavigatorType, class MonomType>

MonomType polybori::COrderedIter< NavigatorType, MonomType >::dereference | ( |  | ) | const

inline

Dereferencing operation.

template<class NavigatorType, class MonomType>

const_iterator polybori::COrderedIter< NavigatorType, MonomType >::end | ( |  | ) | const

inline

template<class NavigatorType, class MonomType>

bool polybori::COrderedIter< NavigatorType, MonomType >::equal | ( | const self & | rhs | ) | const

inline

template<class NavigatorType, class MonomType>

idx_type polybori::COrderedIter< NavigatorType, MonomType >::firstIndex | ( |  | ) | const

inline

template<class NavigatorType, class MonomType>

void polybori::COrderedIter< NavigatorType, MonomType >::increment | ( |  | ) |

inline

Incrementation.

template<class NavigatorType, class MonomType>

bool_type polybori::COrderedIter< NavigatorType, MonomType >::isEnd | ( |  | ) | const

inline

Check, whether end of iteration is reached.

template<class NavigatorType, class MonomType>

bool_type polybori::COrderedIter< NavigatorType, MonomType >::isOne | ( |  | ) | const

inline

Determine whether term is one (without explicit constructing)

template<class NavigatorType, class MonomType>

bool_type polybori::COrderedIter< NavigatorType, MonomType >::isZero | ( |  | ) | const

inline

Determine whether term is zero (without explicit constructing)

template<class NavigatorType, class MonomType>

navigator polybori::COrderedIter< NavigatorType, MonomType >::navigation | ( |  | ) | const

inline

Get navigator of term start.

template<class NavigatorType, class MonomType>

const_reverse_iterator polybori::COrderedIter< NavigatorType, MonomType >::rbegin | ( |  | ) | const

inline

template<class NavigatorType, class MonomType>

const_reverse_iterator polybori::COrderedIter< NavigatorType, MonomType >::rend | ( |  | ) | const

inline

## Member Data Documentation

template<class NavigatorType, class MonomType>

term_generator polybori::COrderedIter< NavigatorType, MonomType >::m_getTerm

protected

The functional which defines the dereferecing operation.

template<class NavigatorType, class MonomType>

core_pointer polybori::COrderedIter< NavigatorType, MonomType >::p_iter

protected

A shared pointer to the stack, which carries the current path.

The documentation for this class was generated from the following files:

- BoolePolynomial.h
- COrderedIter.h